<?php

class Traps_Model extends Model
{
	/**
	 * fetch SNMP traps that caused service/tag state change
	 */
	public function fetch_traps_data($problems_only, $host, $sortby, $order)
	{
		$traps = array();
		$states = array('OK', 'WARNING', 'CRITICAL');
		$query = 'SELECT * FROM subservices';
		if (!is_null($host))
		{
			$host = mysql_real_escape_string($host);
			$query .= " WHERE host = '$host'"
				. ($problems_only ? ' AND (state = 1 OR state = 2) AND acknowledged = FALSE' : '');
		}
		elseif ($problems_only)
			$query .= ' WHERE (state = 1 OR state = 2) AND acknowledged = FALSE';

		$query .= ' ORDER BY ' . mysql_real_escape_string($sortby) . ' ' . $order;

		if ($db = @mysql_connect(Kohana::config('traps.db_host') . ':' . Kohana::config('traps.db_port'),
			Kohana::config('traps.db_user'), Kohana::config('traps.db_password'))
			&& @mysql_select_db(Kohana::config('traps.db_name'))
			&& $result = @mysql_query($query))
		{
			while ($row = @mysql_fetch_assoc($result))
				$traps[] = $row;
		}
		return $traps;
	}

	/**
	 * delete SNMP trap from the subservices table
	 */
	public function delete_trap($host, $service, $tag)
	{
		$host = mysql_real_escape_string($host);
		$service = mysql_real_escape_string($service);
		$tag = mysql_real_escape_string($tag);
		$db = @mysql_connect(Kohana::config('traps.db_host') . ':' . Kohana::config('traps.db_port'),
			Kohana::config('traps.db_user'), Kohana::config('traps.db_password'))
			&& @mysql_select_db(Kohana::config('traps.db_name'))
			&& @mysql_query("DELETE FROM subservices WHERE host = '$host' AND service = '$service' AND tag = '$tag'");
	}

	/**
	 * change subservice state
	 */
	public function change_state($host, $service, $tag, $state)
	{
		$host = mysql_real_escape_string($host);
		$service = mysql_real_escape_string($service);
		$tag = mysql_real_escape_string($tag);
		$state = (int)$state;
		$db = @mysql_connect(Kohana::config('traps.db_host') . ':' . Kohana::config('traps.db_port'),
			Kohana::config('traps.db_user'), Kohana::config('traps.db_password'))
			&& @mysql_select_db(Kohana::config('traps.db_name'))
			&& @mysql_query("UPDATE subservices SET state = $state WHERE host = '$host' AND service = '$service' AND tag = '$tag'");
	}

	/**
	 * acknowledge problem
	 */
	public function acknowledge($host, $service, $tag)
	{
		$host = mysql_real_escape_string($host);
		$service = mysql_real_escape_string($service);
		$tag = mysql_real_escape_string($tag);
		$db = @mysql_connect(Kohana::config('traps.db_host') . ':' . Kohana::config('traps.db_port'),
			Kohana::config('traps.db_user'), Kohana::config('traps.db_password'))
			&& @mysql_select_db(Kohana::config('traps.db_name'))
			&& @mysql_query("UPDATE subservices SET acknowledged = TRUE WHERE host = '$host' AND service = '$service' AND tag = '$tag'");
	}
}
