<?php defined('SYSPATH') OR die('No direct access allowed.'); ?>

<script type="text/javascript">
$(document).ready(function(){
	$('.delete_message').click(function(){
		var rows = $(this).parent().siblings();
		$.ajax({
			url: '<?php echo url::site(); ?>traps/delete_message/' + $(rows).eq(0).text(),
			cache: false,
			success: function(){
				location.reload();
			},
			error: function(){
				alert('An unexpected error occured!');
			}
		});
		return false;
	});
});
</script>
<div id="content_header">
	<div id="page_links">
		<ul>
			<li><a href="<?php echo url::base(); ?>application/views/themes/default/traps/op5-trapper-admin-manual.pdf">Manual</a></li>
			<li><?php echo html::anchor('traps/all/', 'Back to "SNMP Traps" page'); ?><li>
		</ul>
	</div>
	<div class="clear"></div>
</div>
<div id="logs">
	<table id="snmp_traps_logs_table">
		<caption><?php echo $title ?></caption>
		<thead>
			<tr>
				<?php
				$fields = array('id', 'time', 'handler', 'message');
				foreach ($fields as $field)
				{
					if ($field == $sortby)
						$direction = ($order == 'asc')? 'SortDown' : 'SortUp';
					else
						$direction = '';
					echo "<th class=\"{$direction}\" onclick=\"location.href='"
						. url::site() . "traps/logs/?sortby={$field}&amp;order=" . ($order == 'asc' ? 'desc' : 'asc')
						. "'\">{$labels[$field]}</th>";
				}
				?>
				<th><?php echo $labels['actions']; ?></th>
			</tr>
		</thead>
		<tbody>
			<?php $odd = true; foreach ($logs as $message) { ?>
			<tr class="<?php echo $odd ? 'odd' : 'even'; ?>">
				<td><?php echo $message['id']; ?></td>
				<td><?php echo $message['time']; ?></td>
				<td><?php echo $message['handler']; ?></td>
				<td width="100%" style="white-space: normal;"><?php echo nl2br($message['message']); ?></td>
				<td><a href="#" class="delete_message">Delete</a></td>
			</tr>
			<?php $odd = !$odd; } ?>
		</tbody>
	</table>
</div>
